'*******************************************************************************
'*  Name    : I2C_Multi_Master TX-Steuerungs Software                          *
'*          ;                                                                  *
'*  Author  : Tomtom DL1MFK                                                    *
'*  Notice  : Copyright (c) 2016                                               *
'*          : All Rights Reserved                                              *
'*  Date    : 09.01.2017                                                       *
'*          :                                                                  *
'*  Version : 0.6d                                                             *
'*          : - MB1501 Einstellung gendert                                   *
'*          :                                                                  *
'*  Version : 0.6c                                                             *
'*          : - Doppelprfung FRAM_Lesen                                       *
'*          :                                                                  *
'*  Version : 0.6b                                                             *
'*          : - bei PTT wartezeit von 5s eingefgt, damit der TX rasten kann   *
'*          :                                                                  *
'*  Version : 0.6a                                                             *
'*          : - Debugs entfern                                                 *
'*          :                                                                  *
'*  Version : 0.5a                                                             *
'*          : - kollisionen und Bushnger in TomTWi.lib gekillt                *
'*          :                                                                  *
'*  Version : 0.4c                                                             *
'*          : - alten Datensatz trotzdem zurckschreiben wird noch verwendet   *
'*          :   deswegen FramDatErr fehler behoben                             *
'*          : - Bei FramDatErr eigene Daten weiter verwenden                   *
'*          :                                                                  *
'*  Version : 0.4b                                                             *
'*          : - TX Frequenzgrenzen gendert 250MHz - 4000MHz                   *
'*          : - StepFaktor auf 128 erweitert                                   *
'*          :                                                                  *
'* Historie : komplett umbau auf Atmega168                                     *
'*          :                                                                  *
'*******************************************************************************
'* Typ Deklarationen:                                                          *
'*                                                                             *
'* TX Typ 1 : Alter TX (MB1501) mit alter Steuerung (PIC 16F88)                *
'*          :                                                                  *
'* TX Typ 2 : Alter TX (MB1501) mit neuer Steuerung (ATMega 8 oder 168 etc)    *
'*          :                                                                  *
'* TX Typ 3 : Neuer TX (ATTiny45) mit neuer Steuerung (ATMega 8 oder 168 etc)  *
'*          :                                                                  *
'*******************************************************************************
$regfile = "M328pdef.dat"
$crystal = 8000000
$baud = 115200
$hwstack = 140
$swstack = 140
$framesize = 140

Const Titel = "TX STRG"
Const Versionsnummer = "6d 01/17"
'*******************************************************************************
'*   LCD-Leitungen                                                             *
'*******************************************************************************
'       LCD       Mega8
'     ------     --------
'       DB4      PortD.6
'       DB5      PortD.7
'       DB6      PortB.1
'       DB7      PortB.0
'       E        PortD.5
'       RS       PortB.7
'       RW       Masse
'       Vdd      5 Volt
'       Vss      Masse
'       Vo       10K-Poti
'
Config Lcdpin = Pin , E = Portd.5 , Rs = Portb.7 , Db4 = Portd.6 , Db5 = Portd.7 , Db6 = Portb.1 , Db7 = Portb.0
Config Lcdbus = 4
Config Lcd = 16 * 2
'*******************************************************************************
'*   Tasten                                                                   *
'*******************************************************************************
Config Pind.2 = Input
Config Pind.3 = Input
Config Pind.4 = Input
Portd.2 = 1                                                ' Pullups einschalten
Portd.3 = 1                                                ' Pullups einschalten
Portd.4 = 1                                                ' Pullups einschalten
T_menu Alias Pind.2                                        ' Menu Taste  PD2 Pin 4
T_ab Alias Pind.3                                          ' Ab-taste    PD3 Pin 5
T_auf Alias Pind.4                                         ' Auf-Taste   PD4 Pin 6
'*******************************************************************************
'*   BIT-Leitungen                                                             *
'*******************************************************************************
Config Pinc.0 = Output
Config Pinc.2 = Output
Config Pinc.3 = Output
P_agc Alias PortC.0                                        ' Video AGC
P_v_pol Alias Portc.2                                      ' Videopolaritt
P_tx_0_1 Alias Portc.3                                     ' TX aus
' Reset-Leitung
'Config PinD.0 = Output
'Prst Alias PortD.0
'*******************************************************************************
'*   Soft-I2C Leitungen                                                        *
'*******************************************************************************
Config Pinb.2 = Output                                     '
Config Pinc.1 = Output                                     '
Config Sda = Portb.2
Config Scl = Portc.1
'*******************************************************************************
'*   Leitungen fr MB1501                                                      *
'*******************************************************************************
Tt_clk Alias Portc.1                                       ' TT-Clock doppelt belegt
Tt_dat Alias Portb.2                                       ' TT-Daten doppelt belegt
Tt_le Alias Portc.2                                        ' TT-Enable doppelt belegt
'*******************************************************************************
'*   TWI setup Hardware I2C-Leitungen                                          *
'*******************************************************************************
Config Twi = 65000                                         ' 65 kHz
$include "TomTWI.bas"                                      ' im selben Verzeichnis
' Kein Slave-Betrieb !!!!
On Twi Twi_mst_slv_isr , Nosave                            ' ISR f. TWI
'*******************************************************************************
'*   I2C Leitungen                                                             *
'*******************************************************************************
T_scl Alias Pinc.5                                          ' Fr Leitung Down Prfung
T_sda Alias Pinc.4
Config Pinc.5 = Input                                       ' Leitungen Hochohmig schalten
Config Pinc.4 = Input
'*******************************************************************************
'*    Timer Konfiguration                                                      *
'*******************************************************************************
Config Timer0 = Timer , Prescale = 1024                     ' konfiguriere Timer0 fr Framabfrage
On Timer0 Fram_timer                                        ' Fram-Abfrage Timer Interrupt Verweis

Config Timer2 = Timer , Prescale = 1024                     ' konfiguriere Timer2 fr Menu-Ausstieg
On Timer2 Menue_timer                                       ' Menu Ausstieg Timer Interrupt Verweis
'*******************************************************************************
'*    Sub-Deklarationen                                                        *
'*******************************************************************************
' Menue-Anzeige
Declare Sub Menue(byref Menuenr As Byte , Byval Maxmenue As Byte)
' TRX 1-8 Zhler
Declare Sub Auf_ab(byref Parameter As Dword , byref Step_khz As Word , byref Faktor_step As Byte , byref  Faktor As Byte , byref Lo_p_m As Byte , byref Lo_x As Word , Byval Pmax As Dword , Byval Pmin As Dword , Byval Ptrx As String)
' Bit ein und ausschalten
Declare Sub Bit_ein_aus(byref Bit_parameter As Byte , Byval Anzeige_bit As String , Byval Max_zustand As Byte , Byval Lcd0 As String , Byval Lcd1 As String , Byval Lcd2 As String )
' Nummer Auf Ab
Declare Sub Nr_auf_ab(byref Nr_parameter As Byte , Byval Nr_step As Byte , Byval Nr_pmax As Byte , Byval Nr_pmin As Byte , Byval Nt_trx As String)
' Step auf ab
Declare Sub Step_auf_ab(byref Step_parameter As Word , Byval Step_step As Word , Byval Step_pmax As Word , Byval Step_pmin As Word , Byval Step_trx As String , Byval Step_einheit As String)
' Step Referenz Einstellung
Declare Sub Step_einstellung(byref Stepxfaktor As Byte , Byref Stepxkhz As Word , Byval Stepxtrx As String , Byval Step__einheit As String)
'*******************************************************************************
'*    Allgemeine Variablen                                                     *
'*******************************************************************************
Dim Ok_cnt As Word                                          ' Zhler fr OK Taste wenn lnger gedrckt
Dim Plus As Byte                                            ' Plus-Flag
Dim Minus As Byte                                           ' Minus Flas
Dim Ok As Byte                                              ' OK 1 OK 2 wenn lang gedrckt
Dim Passt as Byte                                           ' Fram doppel lese vergleich

Dim I As Byte                                               ' universelle Zhler

Dim Restart As Byte                                         ' Ausstieg aus Menues
Dim Bit_byte As Byte                                        ' Byte-Bit Umwandlung

Dim Temp As Byte                                            ' Temp Byte
Dim Temp_w As Word                                          ' Temp Word
Dim Temp_step As Word
Dim Temp_DW As Dword                                        ' Variablen fr 32bit Berechnungen
Dim Text_tmp As String * 8                                  ' LCD Speicher
Dim Parameter_temp As Dword                                 ' Variablen fr 32bit Berechnungen
Dim Parameter_temp1 As Dword
Dim Xmenuenr As Byte
Dim Zeilenarray(13) As String * 8                           ' Menue Text Speicher

Dim Twi_fehler_cnt As Word                                  ' TWI Fehlerzhler
Dim Fram_timer_cnt As Word                                  ' Timer Zhler
Dim Fram_timer_flag As Bit                                  ' Timer Flag
Dim Menue_timer_cnt As Word                                 ' Timer Zhler
Dim Menue_timer_flag As Bit                                 ' Timer Flag

Dim Sda_scl_pc As Word                                      ' Leitung tot Zhler

Dim Sp_pll As Word
Dim I2c_err As Byte                                         ' Soft  I2C-Fehler
Dim Pllstat As Byte                                         ' PLL Statusbit SP5055
Locked Alias Pllstat.6                                      ' Lock-Bit SP5055
Dim Refresh As Byte                                         ' Anzeige auffrischen Flag
Dim FramDatErrCnt as Byte                                   ' FramDatErr Schleifenzhler
'--------- Tontrger Variable -----------
Dim A1 As Word
Dim A2 As Word
Dim A3 As Word
Dim A4 As Word
Dim N2 As Word
Dim N3 As Word
Dim Tt_16_ref As Word                                       ' 16 Bit Referenz-Teiler
Tt_sw_ref Alias Tt_16_ref.15                                ' SW-Bit 1=64 0=128 Referenz Vor-Teiler
Tt_c_ref Alias Tt_16_ref.0                                  ' Controlbit = 1 fr Referenz-Register
Dim Tt_swallow As Byte                                      ' 7 Bit Swallow-Teiler
Tt_c_prog Alias Tt_swallow.0                                ' Controlbit = 0 fr Prog-Swallow Register
Dim Tt_prog As Word                                         ' 11 Bit Prog-Counter
Dim Tt_n As Word
Dim Tt_n_h As Byte
Dim Tt_n_l As Byte
'--------- Tontrger Variable -----------




'++++++++++++++++++
'+ Daten im Fram: +
'++++++++++++++++++


' 0  TX Adresse 100:    15 Bytes
'________________
' 1  Lo SP PLL      ' SP5055 in 125kHz Schritten
' 2  Hi SP PLL      ' Teilerfaktor   von 4000 bis 21200
' 3  Lo TT PLL      ' MB1501 LO= 27MHz  F=TT+LO
' 4  Hi TT PLL      ' Teilerfaktor   von 32000 bis 36000
' 5  PTT            ' PTT Zustand
' 6  VAGC           ' Video-AGC-Zustand
' 7  PLL NA ERR     ' PLL Fehler speicher
' 8  EE-Daten       ' Konfiguration des Einschubs
'                   '    EE_Daten     var byte
'                   '    Use_FRam     var EE_Daten.0
'                   '    Use_Lock     var EE_Daten.1
'                   '    Use_PLL      var EE_Daten.2
' Ab hier neue Daten Frequenzangabennur noch in kHz, bzw Tontrger in10 kHz
' 9  Byte0 XX PLL  | in kHz
' 10 Byte1 XX PLL  |
' 11 Byte2 XX PLL  | von 500.000kHz bis 3.000.000kHz
' 12 Byte3 XX PLL  |
' 13 Step_Lo | in kHz
' 14 Step_Hi | von 1kHz bis 65535   kHz
' 15 Step_Faktor    1-10
' 16 Lo TT QRG | in 10kHz 500 = 5Mhz 775 = 7,75Mhz
' 17 Hi TT QRG | von 500 bis 1000
' 18 Pos_Neg Video
' 19 Lo TX LO | in MHz
' 20 Hi TX LO | 0 bis 47000
' 21 0+-Lo Einstellung 0=0, 1=+ 2=-
' 22 Vervielfachung   1 - 10
' 23 TX-Typ
'
'    Adresse 200:    1 Byte
'________________
'

' Variablen
Dim Twi_tx_buff(24) As Byte                                 ' TWI Sende bytes
Dim Tx_addr As Byte At Twi_tx_buff Overlay                  ' Adresse des ersten Bytes im Fram
Dim Tx_pll As Word At Twi_tx_buff + 1 Overlay
Dim Tx_tt_pll As Word At Twi_tx_buff + 3 Overlay
Dim Tx_ptt As Byte At Twi_tx_buff + 5 Overlay
Dim Tx_vagc As Byte At Twi_tx_buff + 6 Overlay
Dim Tx_pll_na_err As Byte At Twi_tx_buff + 7 Overlay
Dim Tx_pll_ee_daten As Byte At Twi_tx_buff + 8 Overlay
x_use_fram Alias Tx_pll_ee_daten.0
Tx_use_lock Alias Tx_pll_ee_daten.1
Tx_use_pll Alias Tx_pll_ee_daten.2
'neue Daten
Dim Tx_qrg As Dword At Twi_tx_buff + 9 Overlay
Dim Tx_qrg_step As Word At Twi_tx_buff + 13 Overlay
Dim Tx_faktor_step As Byte At Twi_tx_buff + 15 Overlay
Dim Tx_tt As Word At Twi_tx_buff + 16 Overlay
Dim Tx_vid_pos_neg As Byte At Twi_tx_buff + 18 Overlay
Dim Tx_lo As Word At Twi_tx_buff + 19 Overlay
Dim Tx_lo_p_m As Byte At Twi_tx_buff + 21 Overlay
Dim Tx_faktor As Byte At Twi_tx_buff + 22 Overlay
Dim Tx_typ As Byte At Twi_tx_buff + 23 Overlay

' Temp Lese Variablen fr Prfung
Dim Twi_tx_buff_t(24) As Byte                               ' TWI Sende bytes
Dim T_tx_addr As Byte At Twi_tx_buff_t Overlay              ' Adresse des ersten Bytes im Fram
Dim T_tx_pll As Word At Twi_tx_buff_t + 1 Overlay
Dim T_tx_tt_pll As Word At Twi_tx_buff_t + 3 Overlay
Dim T_tx_ptt As Byte At Twi_tx_buff_t + 5 Overlay
Dim T_tx_vagc As Byte At Twi_tx_buff_t + 6 Overlay
Dim T_tx_pll_na_err As Byte At Twi_tx_buff_t + 7 Overlay
Dim T_tx_pll_ee_daten As Byte At Twi_tx_buff_t + 8 Overlay
T_x_use_fram Alias T_tx_pll_ee_daten.0
T_tx_use_lock Alias T_tx_pll_ee_daten.1
T_tx_use_pll Alias T_tx_pll_ee_daten.2
'neue Daten
Dim T_tx_qrg As Dword At Twi_tx_buff_t + 9 Overlay
Dim T_tx_qrg_step As Word At Twi_tx_buff_t + 13 Overlay
Dim T_tx_faktor_step As Byte At Twi_tx_buff_t + 15 Overlay
Dim T_tx_tt As Word At Twi_tx_buff_t + 16 Overlay
Dim T_tx_vid_pos_neg As Byte At Twi_tx_buff_t + 18 Overlay
Dim T_tx_lo As Word At Twi_tx_buff_t + 19 Overlay
Dim T_tx_lo_p_m As Byte At Twi_tx_buff_t + 21 Overlay
Dim T_tx_faktor As Byte At Twi_tx_buff_t + 22 Overlay
Dim T_Tx_typ As Byte At Twi_tx_buff_t + 23 Overlay

' Temp2 Lese Variablen fr Prfung
Dim Twi_tx_buff_t2(24) As Byte                               ' TWI Sende bytes
Dim T2_tx_addr As Byte At Twi_tx_buff_t2 Overlay              ' Adresse des ersten Bytes im Fram
Dim T2_tx_pll As Word At Twi_tx_buff_t2 + 1 Overlay
Dim T2_tx_tt_pll As Word At Twi_tx_buff_t2 + 3 Overlay
Dim T2_tx_ptt As Byte At Twi_tx_buff_t2 + 5 Overlay
Dim T2_tx_vagc As Byte At Twi_tx_buff_t2 + 6 Overlay
Dim T2_tx_pll_na_err As Byte At Twi_tx_buff_t2 + 7 Overlay
Dim T2_tx_pll_ee_daten As Byte At Twi_tx_buff_t2 + 8 Overlay
T2_tx_use_fram Alias T2_tx_pll_ee_daten.0
T2_tx_use_lock Alias T2_tx_pll_ee_daten.1
T2_tx_use_pll Alias T2_tx_pll_ee_daten.2
'neue Daten
Dim T2_tx_qrg As Dword At Twi_tx_buff_t2 + 9 Overlay
Dim T2_tx_qrg_step As Word At Twi_tx_buff_t2 + 13 Overlay
Dim T2_tx_faktor_step As Byte At Twi_tx_buff_t2 + 15 Overlay
Dim T2_tx_tt As Word At Twi_tx_buff_t2 + 16 Overlay
Dim T2_tx_vid_pos_neg As Byte At Twi_tx_buff_t2 + 18 Overlay
Dim T2_tx_lo As Word At Twi_tx_buff_t2 + 19 Overlay
Dim T2_tx_lo_p_m As Byte At Twi_tx_buff_t2 + 21 Overlay
Dim T2_tx_faktor As Byte At Twi_tx_buff_t2 + 22 Overlay
Dim T2_tx_typ As Byte At Twi_tx_buff_t2 + 23 Overlay

' Feststehend:
Tx_addr = 100
T_tx_addr = 100
T2_tx_addr = 100
'*******************************************************************************
'*    Menue Variablen, Konstanten,Funktionen                                   *
'*******************************************************************************
Const Qrg = "QRG"
Const Steps = "Step"
Const Ttqrg = "TonTrger"
Const Lockbit = "L-bit"
Const Video = "VideoPol"
Const Leer = " "
Const Ein = "Ein"
Const Aus = "Aus"
Const Pos = "Pos"
Const Nega = "Neg"
Const Ufram = "UseFram"
Const Mhz = "MHz"
Const Khz = "kHz"
Const X_typ = "Typ"
Const Tx = "TX "
Const Lo = "Lo QRG"
Const Lo_p_n = "Lo +0-"
Const Agc = "AGC "
Const Ptt = "PTT"
Const Pll_0_1 = "PLL 0/1"
Const Mfaktor = "Faktor"
'*******************************************************************************
'*   Konstanten fr PLL-ICs                                                    *
'*******************************************************************************
Const Addr1 = &HC2                                          ' %11000010=$C2 immer gltige I2C-Schreib-Adresse SP5055
Const Addr2 = &HC3                                          ' %11000011=$C3 immer gltige I2C-Lese-Adresse SP5055
Const Addr_adf = &H68                                       ' ATTiny45 ADF Wandler

Const Xmenuemax = 13

Const Versuche = 5                                          ' Anzahl der maximalen Fehlversuche den IC-Bus zu bedienen
Const Fram_addr = 160                                       ' I2C-Adresse (160)

Const Menue_timeout = 1000                                  ' 255*1024/8MHz=32,64ms  33ms* 1000= 30s
Const Fram_timeout = 30                                    ' 255*1024/8MHz=32,64ms  33ms* 30= 1s
'*******************************************************************************
'*  Initialisierung                                                            *
'*******************************************************************************
Init:
   P_tx_0_1 = 0
   Gosub Tasten_pause
   Gosub Tasten_pause
   Gosub Tasten_pause
   Readeeprom Tx_pll , 0
   Readeeprom Tx_tt_pll , 2
   Readeeprom Tx_ptt , 4
   Readeeprom Tx_vagc , 5
   Readeeprom Tx_pll_na_err , 6
   Readeeprom Tx_pll_ee_daten , 7
   Readeeprom Tx_qrg , 8
   Readeeprom Tx_qrg_step , 12
   Readeeprom Tx_faktor_step , 14
   Readeeprom Tx_tt , 15
   Readeeprom Tx_vid_pos_neg , 17
   Readeeprom Tx_lo , 18
   Readeeprom Tx_lo_p_m ,20
   Readeeprom Tx_faktor ,21
   Readeeprom Tx_Typ, 22


   Cursor Off Noblink
   Cls                                                      ' Clear LCD screen
   Lcd Titel                                                ' Was zum lesen
   'Print Titel
   Lowerline
   Lcd Versionsnummer
   'Print Versionsnummer
   Waitms 500
   Menue_timer_cnt = 1                                      ' Menue_timeout 0
   Fram_timer_cnt = Fram_timeout
   xmenuenr = 1
   Restart = 1
   Enable Timer0                                            ' schalte den Timer0 Overflow Interrupt Ein
   Enable Timer2                                            ' schalte den Timer2 Overflow Interrupt Ein
   Enable Interrupts
   Gosub Start_Lesen                                        ' Falls FRAM aus hier daten lesen
   Gosub Alles_ausgeben                                     ' Werte im Tuner setzen
   Gosub x_menue_fuellen
   '*******************************************************************************
   '*    MenueStruktur                                                            *
   '*******************************************************************************
Menu_routine:
   Do
      Call Menue(xmenuenr , xmenuemax)
      Select Case xmenuenr
         Case 1                                                   ' TX QRG
            Call Auf_ab(tx_qrg , Tx_qrg_step , Tx_faktor_step , Tx_faktor , Tx_lo_p_m , Tx_lo , 4000000 , 250000 , Qrg)
         Case 2                                                   ' TX Schrittweite
            Call Step_einstellung(tx_faktor_step , Tx_qrg_step , "Step" , Khz)
         Case 3                                                   ' TX Tontrger
            Text_tmp = "0" + Khz
            Call Step_auf_ab(tx_tt , 1 , 1000 , 500 , Ttqrg , Text_tmp)
         Case 4                                                   ' TX Video pos neg
            Bit_byte = Tx_vid_pos_neg
            Call Bit_ein_aus(bit_byte , Video , 1 , Pos , Nega , "")
            Tx_vid_pos_neg = Bit_byte.0
            Gosub Alles_ausgeben
            Gosub Trx_fram_schreiben
         Case 5                                                   ' TX ZF bzw Lo
            Call Step_auf_ab(tx_lo , 1 , 47000 , 0 , Lo , Mhz)
         Case 6                                                   ' TX Lo _0 + -
            Bit_byte = Tx_lo_p_m
            Call Bit_ein_aus(Bit_byte , Lo_p_n , 2 , "0" , "+" , "-")
            Tx_lo_p_m = Bit_byte
            Gosub Trx_fram_schreiben
         Case 7                                                   ' TX Faktor
            Call Nr_auf_ab(tx_faktor , 1 , 10 , 1 , Mfaktor)
            Gosub Trx_fram_schreiben
         Case 8                                                   ' TX PTT An / Aus
            Bit_byte = Tx_ptt
            Call Bit_ein_aus(Bit_byte , Ptt , 1 , Aus , Ein , "")
            Tx_ptt = Bit_byte.0
            Gosub Alles_ausgeben
            Gosub Trx_fram_schreiben
         Case 9                                                   ' TX Video Agc An / Aus
            Bit_byte = tx_vagc
            Call Bit_ein_aus(Bit_byte , Agc , 1 , Aus , Ein , "")
            tx_vagc = Bit_byte.0
            Gosub Alles_ausgeben
            Gosub Trx_fram_schreiben
         Case 10                                                  ' TX Lock bit An / Aus
            Bit_byte = Tx_use_lock
            Call Bit_ein_aus(bit_byte , Lockbit , 1 , Aus , Ein , "")
            Tx_use_lock = Bit_byte.0
            Gosub Trx_fram_schreiben
         Case 11                                                  ' TX PLL An / Aus
            Bit_byte = Tx_use_pll
            Call Bit_ein_aus(bit_byte , Pll_0_1 , 1 , Aus , Ein , "")
            Tx_use_pll = Bit_byte.0
            Gosub Trx_fram_schreiben
         Case 12                                                  ' TX Fram An / Aus
            Bit_byte = x_use_fram
            Call Bit_ein_aus(bit_byte , Ufram , 1 , Aus , Ein , "")
            x_use_fram = Bit_byte.0
            Gosub Trx_fram_schreiben
         Case 13                                                  ' TX Typ  kann nur Typ 2 oder 3 Sein !!!!
            Text_tmp = Tx + X_typ
            Bit_byte = Tx_typ
            Call Nr_auf_ab(bit_byte , 1 , 3 , 1 , Text_tmp)
            Tx_typ = Bit_byte
            Gosub Trx_fram_schreiben
      End Select
   Loop
   '*******************************************************************************
   '*    Muens fllen                                                            *
   '*******************************************************************************
x_menue_fuellen:
   'TX-Menue
   Zeilenarray(1) = Qrg
   Zeilenarray(2) = Steps                                'Mit kHz Einstellung !!!
   Zeilenarray(3) = Ttqrg
   Zeilenarray(4) = Video
   Zeilenarray(5) = Lo
   Zeilenarray(6) = Lo_p_n
   Zeilenarray(7) = Mfaktor
   Zeilenarray(8) = Ptt
   Zeilenarray(9) = Agc
   Zeilenarray(10) = Lockbit
   Zeilenarray(11) = Pll_0_1
   Zeilenarray(12) = Ufram
   Text_tmp = Tx + X_typ
   Zeilenarray(13) = Text_tmp
Return
'*******************************************************************************
'*   Gemeinsame Funktionen von RX und TX Steuerung                             *
'*******************************************************************************
$include EWMS Module.bas
'*******************************************************************************
'*   Step Auf/Ab Routine                                                       *
'*******************************************************************************
S_Sonder:
   'Fr alte TX-Tontrger-Daten die Berechnung starten
   Gosub Trx_fram_schreiben
   If xmenuenr = 3 Then
      If TX_Typ = 2 Then
         'Tt_prog = Step_parameter * 10
         Gosub Write_MB1501
      end if
      If TX_Typ = 3 Then Gosub Write_adf_at45
   end if
return
'*******************************************************************************
'*    Tastaturabfrage raus kommt: Plus=1 Minus=1 OK=1 oder OK=2                *
'*******************************************************************************
T_Sonder:
   If tx_use_lock = 1 And xmenuenr = 1 Then               ' gewnscht, im QRG-Men
      Gosub Read_sp5055                                     ' Lockbit auslesen und anzeigen
      Locate 1 , 7
      If I2c_err = 1 Then                                   ' Bei I2C-Fehler "E" anzeigen
         Lcd "E"
      Else
         If Locked = 1 Then Lcd "L"                         ' Gelocked
         If Locked = 0 Then Lcd "X"                         ' Unlocked
      End If
   End If
return
'*******************************************************************************
'*    Fram lesen und schreiben                                                 *
'*******************************************************************************
'++++++++++++++++++
'+ Fram Schreiben +
'++++++++++++++++++
Fram_schreiben:
   'TX Daten schreiben
   Twi_fehler_cnt = 0
   Do
      If Twi_fehler_cnt = Versuche Then Exit Do                ' nach n Versuchen abbrechen
      Twi_mst_addr = Fram_addr                                 ' IC-Adresse (160)
      Twi_mt_cntr = 24                                         ' 24 Byte senden
      Twi_mt_data = Varptr(twi_tx_buff(1))                     ' ab der Adresse sollen die Daten gesendet werden
      Twi_mr_cntr = 0                                          ' 0 zulesenden Daten
      Gosub Run_wait_master                                    ' auf gehts
   Loop Until Twi_mst_flag = 0
Return
'++++++++++++++
'+ Fram lesen +
'++++++++++++++
Fram_lesen:
   'TX Daten lesen
   Twi_fehler_cnt = 0
   Do
      If Twi_fehler_cnt = Versuche Then Exit Do              ' nach n Versuchen abbrechen
      Twi_mst_addr = Fram_addr                                 ' IC-Adresse (160)
      Twi_mt_cntr = 1                                          ' 1 Byte senden
      Twi_mt_data = Varptr(twi_tx_buff_t(1))                  ' ab der Adresse sollen die Daten gesendet werden
      Twi_mr_cntr = 23                                         ' 23 Bytes zulesenden Daten
      Twi_mr_data = Varptr(twi_tx_buff_t(2))                  ' ab der Adresse sollen die Daten gesendet werden
      Gosub Run_wait_master                                   ' auf gehts
   Loop Until Twi_mst_flag = 0
Return
'+++++++++++++++++++
'+ Zusammengefasst +
'+++++++++++++++++++
Trx_fram_schreiben:
   Gosub Alles_ins_eeprom
   If x_use_fram = 0 Then Return
   Gosub Fram_schreiben
Return
Trx_fram_lesen:
   If x_use_fram = 0 Then Return
Start_Lesen:
   Gosub Fram_lesen
   'FRam erneutlesen vorbereiten:
   'Variablen umkopieren:
   For i =1 to 24
      Twi_Tx_buff_t2(i) =Twi_tx_buff_t(i)
   next
   'Erneut lesen
   if Twi_mst_flag = 0 Then
      Gosub Fram_lesen
   else
      Return
   end if
   ' Vergleichen
   Passt=0
   For i =1 to 24
      IF Twi_Tx_buff_t2(i) <> Twi_tx_buff_t(i) Then Passt = Passt + 1
   next

   If Twi_mst_flag  = 0 and Passt = 0 Then
      Gosub Fram_daten_pruefen
   end if
   if passt > 150 then Gosub Fram_daten_pruefen
Return

Alles_ins_eeprom:
   Writeeeprom Tx_ptt , 4
   Writeeeprom Tx_vagc , 5
   Writeeeprom Tx_pll_na_err , 6
   Writeeeprom Tx_pll_ee_daten , 7
   Writeeeprom Tx_qrg , 8
   Writeeeprom Tx_qrg_step , 12
   Writeeeprom Tx_faktor_step , 14
   Writeeeprom Tx_tt , 15
   Writeeeprom Tx_vid_pos_neg , 17
   Writeeeprom Tx_lo , 18
   Writeeeprom Tx_lo_p_m ,20
   Writeeeprom Tx_faktor ,21
   Writeeeprom Tx_Typ, 22
Return
'*******************************************************************************
'*    Fram Daten prfen + bergeben                                            *
'*    TX und RX Daten liegen doppelt vor                                       *
'*******************************************************************************
Fram_daten_pruefen:
   'zuerst berprfen ob sich ein Wert gendert hat.
   if Tx_pll <> T_tx_pll Or _
      Tx_tt_pll <> T_tx_tt_pll Or _
      Tx_ptt <> T_tx_ptt Or _
      Tx_vagc <> T_tx_vagc Or _
      Tx_pll_ee_daten <> T_tx_pll_ee_daten Or _
      Tx_qrg <> T_tx_qrg Or _
      Tx_qrg_step <> T_tx_qrg_step Or _
      Tx_faktor_step <> T_tx_faktor_step Or _
      Tx_tt <> T_tx_tt Or _
      Tx_vid_pos_neg <> T_tx_vid_pos_neg Or _
      Tx_lo <> T_tx_lo Or _
      Tx_lo_p_m <> T_tx_lo_p_m Or _
      Tx_faktor <> T_tx_faktor Or _
      Tx_typ <> T_tx_typ Then
      ' Prfen auf sinnvolle Daten
      if T_tx_ptt > 1 Or _
         T_tx_vagc > 1 Or _
         T_tx_pll_ee_daten > 8 Or _
         T_tx_qrg > 4000000 Or _
         T_tx_qrg < 250000 Or _
         T_tx_qrg_step = 0 Or _
         T_tx_faktor_step = 0 Or _
         T_tx_faktor_step > 128 Or _
         T_tx_tt < 500 Or _
         T_tx_tt > 1000 Or _
         T_tx_vid_pos_neg > 1 Or _
         T_tx_lo > 47000 Or _
         T_tx_lo_p_m > 3 Or _
         T_tx_faktor = 0 Or _
         T_tx_faktor > 10 or _
         T_tx_typ = 0 or _
         T_tx_typ > 10 Then
         ' letzte gltigen Daten schreiben
         ' in Fram ablegen und Fehleranzeigen
         Locate 1 , 1
         Lcd "FramDatErr"
         Waitms 500
         Gosub Trx_fram_schreiben
         Refresh = 1
      Else
         ' Daten sind gltig also bernehmen
         For I = 2 To 24
            Twi_tx_buff(i) = Twi_tx_buff_t(i)               ' alte Bytes berspringen
         Next
         Gosub Alles_ins_eeprom
         Gosub Alles_ausgeben                               ' Werte im TX setzen
         Refresh = 1
      End If
   End If                                                   ' Neue Werte Anzeigen
Return
'*******************************************************************************
'*    Soft-I2C-Routinen                                                        *
'*******************************************************************************
Write_sp5055:
  'If Tx_ptt = 0 then return
   I2cinit
   I2cstart
   I2cwbyte Addr1
   Temp = High(sp_pll)
   I2cwbyte Temp
   Temp = Low(sp_pll)
   I2cwbyte Temp
   Temp = &HCE
   I2cwbyte Temp
   Temp = 0
   I2cwbyte Temp
   I2cstop
   I2c_err = Err
Return

Read_sp5055:
   If Tx_ptt = 0 then return
   I2cinit
   I2cstart
   I2cwbyte Addr2
   I2crbyte Pllstat , Nack
   I2cstop
   I2c_err = Err
Return

Write_adf_at45:
   If Tx_ptt = 0 then return
   I2cinit
   I2cstart
   I2cwbyte Addr_adf
   Waitus 15
   Temp = High(tx_tt)
   I2cwbyte Temp
   Waitus 15
   Temp = Low(tx_tt)
   I2cwbyte Temp
   I2cstop
   I2c_err = Err

Return

Write_MB1501:
   'If Tx_ptt = 0 then return
   Tt_prog = tx_tt*10
   Tt_prog = Tt_prog + 27000
   Tt_16_ref = 13500 * 2                                      ' bei 13,5 MHz Ref = 13500 => 1kHz
   'print "tx_tt";tx_tt                                       ' TT_16_Ref nach links schieben
                                                             ' um Platz fr das Referenz-
                                                             ' Control-Bit zu bekommen
   N2 = Tt_prog \ 64                                         ' Testteilung durch 64
   A1 = tt_prog Mod 64
   N3 = Tt_prog \ 128                                        ' Testteilung durch 128
   A3 = Tt_Prog Mod 128                                      ' Rest berechnen
   If A3 < N3 Then                                           '
      Tt_n = N3
      Tt_swallow = A3 * 2                                    ' 1 mal nach linksschieben um fr das
                                                             ' Controlbit Platz zu schaffen
      Tt_sw_ref = 0                                          ' SW-Bit=0 128
   Else
      Tt_n = N2
      Tt_swallow = A1 * 2                                    ' 1 mal nach linksschieben um fr das
                                                             ' Controlbit Platz zu schaffen
      Tt_sw_ref = 1                                          ' SW-Bit=1 64
   End If
   Tt_c_ref = 1                                              ' Kontroll Bit fr Referenz-Teiler = 1
   Tt_c_prog = 0                                             ' Kontroll Bit = 0 fr Swallow und N Register
  'Print "Teiler A1 :" ; A1
  'Print "Teiler A3 :" ; A3
  'Print "Teiler N2 :" ; N2
  'Print "Teiler N3 :" ; N3
   Shiftout Tt_dat , Tt_clk , Tt_16_ref , 1
   Gosub Sr_lesen
   'print "Tt_n"; tt_n
   Tt_n_h = High(tt_n)
   shift Tt_n_h ,LEFT, 5                                     ' fr Shiftout an die richtige Stelle schieben
   Tt_n_l = Low(tt_n)
   Shiftout Tt_dat , Tt_clk , Tt_n_h , 1 ,  3
   Shiftout Tt_dat , Tt_clk , Tt_n_l , 1
   Shiftout Tt_dat , Tt_clk , Tt_swallow , 1
Sr_lesen:
   Waitus 1
   Set Tt_le
   Waitus 1
   Reset Tt_le
return

Alles_ausgeben:
   'Teiler_berechnen
   'print "Alles_ausgeben"
   'Print "TX-Typ: "; tx_typ
   Temp_DW = Tx_qrg / Tx_qrg_step
   Sp_pll = Temp_DW
   P_v_pol = not Tx_vid_pos_neg.0                            ' Videopolaritt
   P_agc = Not Tx_vagc.0                                     ' Video AGC   OK !!
   Gosub Write_sp5055                                        ' PLL setzen
   Select Case tx_typ
      Case 2
         Gosub Write_MB1501
      Case 3
         Gosub Write_adf_at45                                ' Tontrger setzen
   End Select
   If P_tx_0_1 < Tx_ptt.0 Then                               ' PTT Warteschleife
      Waitms 5000
   End if
   P_tx_0_1 =  Tx_ptt.0                                      ' TX einaus  OK !!
Return
'*******************************************************************************
'*   EEPromwerte beim Brennen speichern                                        *
'*******************************************************************************
$eeprom
'Data 6560%                                                  ' 0  2 Byte RX Teilerfaktor
'Data 1204224&                                               ' 2  4 Bytes RX QRG in KHz
'Data 1200000&                                               ' 2  4 Bytes RX QRG in KHz
'Data 125%                                                   ' 6  2 Bytes RX QRG Step in kHz
'Data 1                                                      ' 8  1 Byte RX Step Faktor
'Data 650%                                                   ' 9  2 Bytes RX Tontrger QRG in 10kHz
'Data 0                                                      ' 11 1 Byte RX Video Pos/Neg
'Data &B0001_1111                                            ' 12 1 Byte RX Flags
'Data 10000%                                                 ' 13 2 Bytes RX-LO in MHz
'Data 0                                                      ' 15 1 Byte RX-LO 0 + -
'Data 2                                                      ' 16 1 Byte RX alr  neu

'Data 9600%                                                  ' 16 2 Byte TX Teilerfaktor
'Data 33500%                                                 ' 18 2 Byte TX Tontrger Teilerfaktor
' Daten vertauscht !!!!!!!!
Data 32805%                                                 ' 16 2 Byte TX Teilerfaktor
Data 56450%                                                 ' 18 2 Byte TX Tontrger Teilerfaktor
Data 1                                                      ' 20 1 Byte TX PTT
Data 1                                                      ' 21 1 Byte TX Video-AGC
Data 0                                                      ' 22 1 Byte TX Pll Lock Fehlerzhler
Data &B0000_0111                                            ' 23 1 Byte TX Steuerkarten Konfiguration
Data 1280000&                                               ' 24 4 Bytes TX QRG in KHz
Data 125%                                                   ' 28 2 Bytes TX QRG Step in kHz
Data 1                                                      ' 30 1 Byte TX Step Faktor
Data 650%                                                   ' 31 2 Byte TX Tontrger QRG in 10kHz
Data 1                                                      ' 33 1 Byte TX Video Pos/Neg
Data 10000%                                                 ' 34 2 Bytes TX-LO in MHz
Data 0                                                      ' 36 1 Byte TX-LO 0 + -
Data 1                                                      ' 37 1 byte TX Vervielfachung
Data 3                                                      ' 38 1 byte TX Typ